<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelatoriosDiversosService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;

    }

	public function getVND0161H($conditions){
    	$params = array(
            ":CDFILIAL"       => $conditions['CDFILIAL'],
            ":TCDFILIAL"      => 'ZZZZZ',
            ":CDLOJA"         => $conditions['CDLOJA'],
            ":TCDLOJA"        => $conditions['TCDLOJA'],
            ":DTINI"          => $conditions['DTINI'],
            ":DTFIN"          => $conditions['DTFIN']
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VND0161H, $params);
	}

    const GET_VND0161H = "
        SELECT R.CDFILIAL||' - '||F.NMFILIAL AS CDNMFILIAL, R.CDCAIXA ||' - '|| C.NMCAIXA AS CDNMCAIXA, TO_CHAR(R.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA, R.QTVENDASMSDE, R.QTVENDASORACLE, R.DTULTATU, ABS(R.QTVENDASMSDE - R.QTVENDASORACLE) AS DIFERENCA
          FROM FILIAL F, CAIXA C, RELVENDAS R
         WHERE C.CDFILIAL = R.CDFILIAL
           AND C.CDCAIXA  = R.CDCAIXA
           AND F.CDFILIAL = R.CDFILIAL
           AND R.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
           AND ((INSTR(:CDLOJA  , C.CDFILIAL||C.CDLOJA) <> 0) OR (:TCDLOJA   = 'T')) 
           AND ((INSTR(:CDFILIAL, F.CDFILIAL          ) <> 0) OR (:TCDFILIAL = 'T'))
           AND R.QTVENDASMSDE <> R.QTVENDASORACLE
        ORDER BY R.CDFILIAL, DIFERENCA DESC, R.CDCAIXA, R.DTENTRVENDA
    ";
    
    public function getVND01620($conditions){
    	$params = array(
            ":CDFILIAL"       => $conditions['CDFILIAL'],
            ":TCDFILIAL"      => 'ZZZZZ',
            ":CDTIPORECE"     => $conditions['CDTIPORECE'],
            ":TCDTIPORECE"    => $conditions['TCDTIPORECE'],
            ":DTINI"          => $conditions['DTINI'],
            ":DTFIN"          => $conditions['DTFIN']
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VND01620, $params);
	}

    const GET_VND01620 = "
        SELECT V.CDFILIAL||' - '||F.NMFILIAL AS CDNMFILIAL, M.CDCAIXA ||' - '|| C.NMCAIXA AS CDNMCAIXA, TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA, M.CDTIPORECE||' - '||T.NMTIPORECE AS CDNMTIPORECE, TRUNC(SUM(DECODE(M.IDTIPOMOVIVE, 'S', -VRMOVIVEND, VRMOVIVEND)), 2) AS VRMOVIVEND
          FROM VENDA V, MOVCAIXA M, CAIXA C, FILIAL F, TIPORECE T
         WHERE ((INSTR(:CDTIPORECE, T.CDTIPORECE) <> 0) OR (:TCDTIPORECE = 'T'))
           AND T.CDTIPORECE  = M.CDTIPORECE
           AND V.CDFILIAL    = M.CDFILIAL
           AND C.CDFILIAL    = V.CDFILIAL
           AND C.CDCAIXA     = M.CDCAIXA
           AND V.CDCAIXA     = M.CDCAIXA
           AND V.NRSEQVENDA  = M.NRSEQVENDA
           AND V.CDFILIAL    = F.CDFILIAL
           AND V.IDSITUVENDA = 'O'
           AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
           AND ((INSTR(:CDFILIAL, F.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
        GROUP BY V.CDFILIAL, F.NMFILIAL, M.CDCAIXA, C.NMCAIXA, V.DTENTRVENDA, M.CDTIPORECE, T.NMTIPORECE
        ORDER BY V.CDFILIAL, M.CDCAIXA, V.DTENTRVENDA, M.CDTIPORECE
    ";

}  